/* msgid2rfc - Converts a MPDUid struct into a RFC string */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/msgid2rfc.c,v 5.0 90/09/20 16:05:05 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/msgid2rfc.c,v 5.0 90/09/20 16:05:05 pp Exp Locker: pp $
 *
 * $Log:	msgid2rfc.c,v $
 * Revision 5.0  90/09/20  16:05:05  pp
 * rcsforce : 5.0 public release
 * 
 */



#include        "util.h"
#include        "mta.h"

extern void globalid2rfc ();
void msgid2rfc_aux();

/* ---------------------  Begin  Routines  -------------------------------- */

void msgid2rfc (msgid, buffer)
MPDUid	*msgid;
char	*buffer;
{
	msgid2rfc_aux (msgid, buffer, FALSE);
}

void msgid2rfc_aux (msgid, buffer, angled)
MPDUid  *msgid;
char    *buffer;
int	angled;
{
	char    tbuf[LINESIZE], buf[BUFSIZ];
	bzero (&tbuf[0], LINESIZE);
	
	globalid2rfc (&msgid -> mpduid_DomId, tbuf);

	if (msgid -> mpduid_string) 
		(void) sprintf(buf, "%c%s;%s%c",
			       (angled == TRUE) ? '<' : '[',
			       tbuf, msgid -> mpduid_string,
			       (angled == TRUE) ? '>' : ']');
	else
		(void) sprintf(buf, "%c%s%c",
			       (angled == TRUE) ? '<' : '[',
			       tbuf,
			       (angled == TRUE) ? '>' : ']');

	(void) strcpy (buffer, buf);

	PP_DBG (("Lib/msgid2rfc returns (%s)", buffer));

	return;
}
