/* or_default: add suitable defaults for or structures */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_default.c,v 5.0 90/09/20 16:08:00 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_default.c,v 5.0 90/09/20 16:08:00 pp Exp Locker: pp $
 *
 * $Log:	or_default.c,v $
 * Revision 5.0  90/09/20  16:08:00  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "or.h"
#include "util.h"

OR_ptr or_default (or)
OR_ptr  or;
{
    OR_ptr              defptr;
    OR_ptr              new_tree;
    OR_ptr              tptr = NULLOR;
    int			before;

    PP_DBG (("Lib/or_default()"));

    new_tree = NULLOR;

    for (defptr = loc_ortree; defptr != NULLOR; defptr = defptr -> or_next) {
	if (or -> or_type <= defptr -> or_type)
		if (or->or_type == OR_OU) {
			if (lexequ (or -> or_value, defptr -> or_value) == 0)
				break;
		}
		else
			break;

	tptr = or_dup (defptr);

	if (tptr -> or_type == OR_OU) 
		before = FALSE; 
	else 
		before = TRUE;

	if ((new_tree = or_add (new_tree, tptr, before)) == NULLOR)
		return NULLOR;
    }

    /*
    As we know both are ordered, tptr will be at the end of the tree
    */

    if (new_tree == NULLOR)
	return (or);

    tptr -> or_next = or;
    or -> or_prev = tptr;

    return (new_tree);
}
