/* rfc2encinfo.c - Converts a RFC string into a EncodedIT struct */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/rfc2encinfo.c,v 5.0 90/09/20 16:05:27 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/rfc2encinfo.c,v 5.0 90/09/20 16:05:27 pp Exp Locker: pp $
 *
 * $Log:	rfc2encinfo.c,v $
 * Revision 5.0  90/09/20  16:05:27  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "util.h"
#include "mta.h"
#include "list_bpt.h"



/* ---------------------  Begin  Routines  -------------------------------- */


static int rfc2listbpt ();

int rfc2encinfo (ep, str)
EncodedIT               *ep;
char                    *str;
{

	PP_DBG (("Lib/rfc2encinfo (%s)", str));
	return rfc2listbpt (&ep->eit_types, str);
}




/* ---------------------  Static  Routines  ------------------------------- */




static int rfc2listbpt (bpt, str)
LIST_BPT                **bpt;
char                    *str;
{
	LIST_BPT        *base = NULLIST_BPT,
			*new;
	char            *cp = str,
			*bp = str;


	PP_DBG (("Lib/rfc2listbpt (%s)", str));

	/* -- read string which delimitted by ',' and an optional ' '  -- */
	while (cp != NULLCP) {
		if (cp = index (bp, ',')) {
			*cp++ = '\0';
			if (*cp == ' ') cp++;
		}
		new = list_bpt_new (bp);
		list_bpt_add (&base, new);
		bp = cp;
	}

	*bpt = base;

	return OK;
}
