/* rd_prm.c: read in a prm_vars struct from fp */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/io/RCS/rd_prm.c,v 5.0 90/09/20 16:06:53 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/io/RCS/rd_prm.c,v 5.0 90/09/20 16:06:53 pp Exp Locker: pp $
 *
 * $Log:	rd_prm.c,v $
 * Revision 5.0  90/09/20  16:06:53  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "head.h"
#include "prm.h"
#include "tb_prm.h"


/* ---------------------  Begin  Routines  -------------------------------- */



int rd_prm (pp, fp)
register struct prm_vars        *pp;
FILE                            *fp;
{
	char    buf[BUFSIZ],
		*argv[50];
	int     argc,
		retval;

	PP_DBG (("Lib/io/rd_prm()"));

	prm_init (pp);

	for (;;) {
		retval = txt2buf (buf, fp);

		if (rp_isbad (retval)) {
			PP_DBG (("Lib/rd_prm txt2buf retval (%d - %s)",
			      retval, rp_valstr (retval)));
			return (retval);
		}

		argc = str2arg (buf, 50, argv);
		if (argc == 0) {
			PP_LOG (LLOG_EXCEPTIONS, ("Lib/rd_prm err (str2arg)"));
			return (RP_PARM);
		}

		retval = txt2prm (pp, argv, argc);
		if (retval == NOTOK) {
			PP_LOG (LLOG_EXCEPTIONS, ("Lib/rd_prm err (txt2prm)"));
			return (RP_PARM);
		}
		if (retval == PRM_END)  return (RP_OK);
	}
}
