/* submit_prm.c: read and process control switches */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Src/submit/RCS/submit_prm.c,v 5.0 90/09/20 16:23:23 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Src/submit/RCS/submit_prm.c,v 5.0 90/09/20 16:23:23 pp Exp Locker: pp $
 *
 * $Log:	submit_prm.c,v $
 * Revision 5.0  90/09/20  16:23:23  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "head.h"
#include "prm.h"
#include "q.h"


extern int      end_of_file;
extern void	err_abrt();


/* -- local routines -- */
int		rd_prm_info();
int		rd_q_info();




/* ---------------------  Begin  Routines  -------------------------------- */




int rd_prm_info (prm)  /* -- read in a prm management structure -- */
struct prm_vars         *prm;
{
	int             retval;

	PP_TRACE (("submit/rd_prm_info (prm)"));

	if (rp_isbad (retval = rd_prm (prm, stdin))) {
		switch (retval) {
		case RP_EOF:
			end_of_file = TRUE;
			break;
		case RP_PARM:
			err_abrt (RP_PARM, "Aborting message");
		}
	}
	return (retval);
}




int rd_q_info (qp)  /* -- read in a queue structure -- */
register Q_struct       *qp;
{
	int             retval;

	PP_TRACE (("submit/rd_q_info (qp)"));

	q_init (qp);

	if (rp_isbad (retval = rd_q (qp, stdin))) {
		 switch (retval) {
		 case RP_EOF:
			end_of_file = TRUE;
			break;
		 case RP_PARM:
			err_abrt (RP_PARM, "Aborting message");
		}
	}
	return (retval);
}
