-- transfer.py: 


-- @(#) $Header: /cs/research/pp/hubris/pp-beta/Tools/mpp88/RCS/transfer.py,v 5.0 90/09/20 16:28:48 pp Exp Locker: pp $
--
-- $Log:	transfer.py,v $
-- Revision 5.0  90/09/20  16:28:48  pp
-- rcsforce : 5.0 public release
-- 
--



Transfer
-- {iso identified-organisation(3) locator(999) modules(0) transfer(8)}
DEFINITIONS IMPLICIT TAGS ::=
BEGIN

IMPORTS 
	MessageTransferEnvelope, Content,
	ReportTransferEnvelope, ReportTransferContent,
	ProbeTransferEnvelope
-- Extras
	,
	MTABindArgument, MTABindResult, MTABindError
-- End Extras
	FROM MTA;

MtsAPDU ::=
	CHOICE {
		message [0] MessageAPDU,
		report  [1] ReportAPDU,
		probe   [2] ProbeTransferEnvelope}

MessageAPDU ::=
	SEQUENCE {
		envelope MessageTransferEnvelope,
		content  Content}

ReportAPDU ::=
	SEQUENCE {
		envelope ReportTransferEnvelope,
		content  ReportTransferContent}

ProbeAPDU ::=
	ProbeTransferEnvelope

--- additions for 1988 BIND macro

Bind1988Argument ::= [16] EXPLICIT MTABindArgument

Bind1988Result ::= [17] EXPLICIT MTABindResult

Bind1988Error ::= [18] EXPLICIT MTABindError

END
