/* table.h: table structures */

/*
 * @(#) $Header: /cs/research/pp/hubris/pp-beta/h/RCS/table.h,v 5.0 90/09/20 16:51:12 pp Exp Locker: pp $
 *
 * $Log:	table.h,v $
 * Revision 5.0  90/09/20  16:51:12  pp
 * rcsforce : 5.0 public release
 * 
 *
 */



#ifndef _H_TABLE
#define _H_TABLE


/*
Information kept for all tables
*/

typedef struct	tb_struct {
	char	*tb_name;	/* internal name of table		*/
	char	*tb_show;	/* displayable human-oriented string	*/
	char	*tb_file;	/* name of file containing table	*/
	FILE	*tb_fp;		/* stdio file pointer			*/
	int	tb_flags;	/* various bits (type of table, etc)	*/
} Table;


#define NULLTBL	       ((Table *)0)

#define TB_SRCMASK	07
#define TB_SRC(x)	((x) & TB_SRCMASK)	/* Source of table data */
#define TB_DBM		01			/* Read from DBM database */
#define TB_NS		02			/* Read from Nameserver */
#define TB_LINEAR	04			/* Read from linear file */


extern	Table	*tb_nm2struct();
extern	Table	*tb_all[];
extern	int	tb_getdomain ();
extern	int	tb_k2val ();
extern	int	tb_dbmk2val ();
extern	int	tab_fetch ();
#endif
